// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             (unknown)
// source: services/simulation_events.proto

package services

import (
	context "context"
	events "gitlab.com/ignitionrobotics/cloudsim/api/events"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SimulationEventsClient is the client API for SimulationEvents service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SimulationEventsClient interface {
	// Succeed triggers a simulation succeeded event.
	Succeed(ctx context.Context, in *events.SimulationSucceeded, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Expire triggers a simulation expired event.
	Expire(ctx context.Context, in *events.SimulationExpired, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Fail triggers a simulation failed event.
	Fail(ctx context.Context, in *events.SimulationFailed, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Request triggers a simulation requested event.
	Request(ctx context.Context, in *events.SimulationRequested, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Schedule triggers a simulation scheduled event.
	Schedule(ctx context.Context, in *events.SimulationScheduled, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Run triggers a simulation running event.
	Run(ctx context.Context, in *events.SimulationRunning, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Finish triggers a simulation finished event.
	Finish(ctx context.Context, in *events.SimulationFinished, opts ...grpc.CallOption) (*SimulationEventResponse, error)
	// Restart triggers a simulation restart event.
	Restart(ctx context.Context, in *events.SimulationRestarted, opts ...grpc.CallOption) (*SimulationEventResponse, error)
}

type simulationEventsClient struct {
	cc grpc.ClientConnInterface
}

func NewSimulationEventsClient(cc grpc.ClientConnInterface) SimulationEventsClient {
	return &simulationEventsClient{cc}
}

func (c *simulationEventsClient) Succeed(ctx context.Context, in *events.SimulationSucceeded, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Succeed", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Expire(ctx context.Context, in *events.SimulationExpired, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Expire", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Fail(ctx context.Context, in *events.SimulationFailed, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Fail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Request(ctx context.Context, in *events.SimulationRequested, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Request", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Schedule(ctx context.Context, in *events.SimulationScheduled, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Schedule", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Run(ctx context.Context, in *events.SimulationRunning, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Run", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Finish(ctx context.Context, in *events.SimulationFinished, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Finish", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *simulationEventsClient) Restart(ctx context.Context, in *events.SimulationRestarted, opts ...grpc.CallOption) (*SimulationEventResponse, error) {
	out := new(SimulationEventResponse)
	err := c.cc.Invoke(ctx, "/services.SimulationEvents/Restart", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SimulationEventsServer is the server API for SimulationEvents service.
// All implementations must embed UnimplementedSimulationEventsServer
// for forward compatibility
type SimulationEventsServer interface {
	// Succeed triggers a simulation succeeded event.
	Succeed(context.Context, *events.SimulationSucceeded) (*SimulationEventResponse, error)
	// Expire triggers a simulation expired event.
	Expire(context.Context, *events.SimulationExpired) (*SimulationEventResponse, error)
	// Fail triggers a simulation failed event.
	Fail(context.Context, *events.SimulationFailed) (*SimulationEventResponse, error)
	// Request triggers a simulation requested event.
	Request(context.Context, *events.SimulationRequested) (*SimulationEventResponse, error)
	// Schedule triggers a simulation scheduled event.
	Schedule(context.Context, *events.SimulationScheduled) (*SimulationEventResponse, error)
	// Run triggers a simulation running event.
	Run(context.Context, *events.SimulationRunning) (*SimulationEventResponse, error)
	// Finish triggers a simulation finished event.
	Finish(context.Context, *events.SimulationFinished) (*SimulationEventResponse, error)
	// Restart triggers a simulation restart event.
	Restart(context.Context, *events.SimulationRestarted) (*SimulationEventResponse, error)
	mustEmbedUnimplementedSimulationEventsServer()
}

// UnimplementedSimulationEventsServer must be embedded to have forward compatible implementations.
type UnimplementedSimulationEventsServer struct {
}

func (UnimplementedSimulationEventsServer) Succeed(context.Context, *events.SimulationSucceeded) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Succeed not implemented")
}
func (UnimplementedSimulationEventsServer) Expire(context.Context, *events.SimulationExpired) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Expire not implemented")
}
func (UnimplementedSimulationEventsServer) Fail(context.Context, *events.SimulationFailed) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Fail not implemented")
}
func (UnimplementedSimulationEventsServer) Request(context.Context, *events.SimulationRequested) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Request not implemented")
}
func (UnimplementedSimulationEventsServer) Schedule(context.Context, *events.SimulationScheduled) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Schedule not implemented")
}
func (UnimplementedSimulationEventsServer) Run(context.Context, *events.SimulationRunning) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Run not implemented")
}
func (UnimplementedSimulationEventsServer) Finish(context.Context, *events.SimulationFinished) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Finish not implemented")
}
func (UnimplementedSimulationEventsServer) Restart(context.Context, *events.SimulationRestarted) (*SimulationEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Restart not implemented")
}
func (UnimplementedSimulationEventsServer) mustEmbedUnimplementedSimulationEventsServer() {}

// UnsafeSimulationEventsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SimulationEventsServer will
// result in compilation errors.
type UnsafeSimulationEventsServer interface {
	mustEmbedUnimplementedSimulationEventsServer()
}

func RegisterSimulationEventsServer(s grpc.ServiceRegistrar, srv SimulationEventsServer) {
	s.RegisterService(&SimulationEvents_ServiceDesc, srv)
}

func _SimulationEvents_Succeed_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationSucceeded)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Succeed(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Succeed",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Succeed(ctx, req.(*events.SimulationSucceeded))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Expire_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationExpired)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Expire(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Expire",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Expire(ctx, req.(*events.SimulationExpired))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Fail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationFailed)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Fail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Fail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Fail(ctx, req.(*events.SimulationFailed))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Request_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationRequested)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Request(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Request",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Request(ctx, req.(*events.SimulationRequested))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Schedule_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationScheduled)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Schedule(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Schedule",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Schedule(ctx, req.(*events.SimulationScheduled))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Run_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationRunning)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Run(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Run",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Run(ctx, req.(*events.SimulationRunning))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Finish_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationFinished)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Finish(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Finish",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Finish(ctx, req.(*events.SimulationFinished))
	}
	return interceptor(ctx, in, info, handler)
}

func _SimulationEvents_Restart_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(events.SimulationRestarted)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationEventsServer).Restart(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationEvents/Restart",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationEventsServer).Restart(ctx, req.(*events.SimulationRestarted))
	}
	return interceptor(ctx, in, info, handler)
}

// SimulationEvents_ServiceDesc is the grpc.ServiceDesc for SimulationEvents service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SimulationEvents_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "services.SimulationEvents",
	HandlerType: (*SimulationEventsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Succeed",
			Handler:    _SimulationEvents_Succeed_Handler,
		},
		{
			MethodName: "Expire",
			Handler:    _SimulationEvents_Expire_Handler,
		},
		{
			MethodName: "Fail",
			Handler:    _SimulationEvents_Fail_Handler,
		},
		{
			MethodName: "Request",
			Handler:    _SimulationEvents_Request_Handler,
		},
		{
			MethodName: "Schedule",
			Handler:    _SimulationEvents_Schedule_Handler,
		},
		{
			MethodName: "Run",
			Handler:    _SimulationEvents_Run_Handler,
		},
		{
			MethodName: "Finish",
			Handler:    _SimulationEvents_Finish_Handler,
		},
		{
			MethodName: "Restart",
			Handler:    _SimulationEvents_Restart_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "services/simulation_events.proto",
}
